#
# MIT License
#
# Copyright Â© 2022 TANGENT NETWORKS
#
# Permission  is  hereby granted, free of charge, to any person ob-
# taining a copy of  this  software  and  associated  documentation
# files  (the "Software"), to deal in the Software without restric-
# tion, including without limitation the rights to use, copy, modi-
# fy, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is  fur-
# nished to do so, subject to the following conditions:
#
# THE  ABOVE  COPYRIGHT  NOTICE AND THIS PERMISSION NOTICE SHALL BE
# INCLUDED IN ALL COPIES OR SUBSTANTIAL PORTIONS OF THE SOFTWARE.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF  ANY  KIND,
# EXPRESS  OR  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE  AND  NONIN-
# FRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER  IN  AN
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN  THE
# SOFTWARE.
#
%global __cmake_in_source_build 1

Name:           vectorscan
Version:        5.4.11
Release:        1
Summary:        Vectorscan, A portable fork of the high-performance regular expression matching library www.hyperscan.io

License:        BSD
URL:            https://github.com/VectorCamp/vectorscan
Source0:        https://github.com/VectorCamp/vectorscan/archive/refs/tags/vectorscan/%{version}.tar.gz#/%{name}-%{name}-%{version}.tar.gz
Patch0:         https://pagure.io/vectorscan_rpm/raw/master/f/0001-documentation-Add-cmake-option-to-build-man-pages.patch
Patch1:         https://pagure.io/vectorscan_rpm/raw/master/f/0001-Change-PPC-default-to-power8.patch

BuildRequires:  patch
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  git
BuildRequires:  make
BuildRequires:  cmake
BuildRequires:  ragel
BuildRequires:  python3-sphinx
BuildRequires:  python3-breathe
BuildRequires:  doxygen
BuildRequires:  boost-devel
BuildRequires:  pcre-devel
BuildRequires:  sqlite-devel
BuildRequires:  glibc-devel
BuildRequires:  python3-devel
BuildRequires:  libpcap-devel


%description
A fork of Intel's Hyperscan, modified to run on more platforms. Hyperscan is a high-performance multiple
regex matching library. It follows the regular expression syntax of the commonly-used libpcre library,
but is a standalone library with its own C API.

%package devel
Summary: Development files for the vectorscan library
Requires: %{name}%{?_isa} = %{version}-%{release}

%description devel
A fork of Intel's Hyperscan, modified to run on more platforms.

This package provides the libraries, include files and other resources
needed for developing Hyperscan applications.

%prep
%setup -q -n %{name}-%{name}-%{version}
%patch -P0 -p1
%patch -P1 -p1

%build
%define _lto_cflags %{nil}
%cmake \
        -DCMAKE_BUILD_TYPE=Release \
        -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
        -DBUILD_SHARED_LIBS:BOOL=ON \
        -DFAT_RUNTIME=ON \
        -DBUILD_SVE=ON \
        -DBUILD_SVE2=ON \
        -DBUILD_SVE2_BITPERM=ON . -Wno-dev

%cmake_build

%install
%cmake_install

%check
bin/unit-hyperscan

%files
%license COPYING
%license LICENSE
%{_libdir}/*.so.*
%doc README.md
%{_mandir}/man7/vectorscan.7.*

%files devel
%dir %{_defaultdocdir}/%{name}
%dir %{_defaultdocdir}/%{name}/examples
%doc %{_defaultdocdir}/%{name}/examples/README.md
%doc %{_defaultdocdir}/%{name}/examples/*.cc
%doc %{_defaultdocdir}/%{name}/examples/*.c
%{_libdir}/*.so
%{_libdir}/pkgconfig/libhs.pc
%{_includedir}/hs/

%changelog
* Fri May 24 2024 Tangent Networks <tangent.net@protonmail.com> 5.4.11-1
- Built initial package for EPEL9, fc39, fc40, and rawhide
- Added manpages
- cleaned up specfile
